sprites.exploSheet = love.graphics.newImage('sprites/explosions.png')
sprites.exploSheet:setFilter('nearest', 'nearest')
sprites.bombs = love.graphics.newImage('sprites/bombs.png')
sprites.bombs:setFilter('nearest', 'nearest')


Bomb = Class{
    init = function(self)
		self.animation = anim8.newAnimation(self.animationGrid('1-6',1), 0.07)
		if math.random()>.5 then
			self.animation = anim8.newAnimation(self.animationGrid('11-16',1), 0.07)
		end
		self.bombDrop = anim8.newAnimation(self.animationGrid(16,2), 0.07)
		self.blackBomb = anim8.newAnimation(self.bombGrid(1,1), 0.07)
		
		self.explosion1 = anim8.newAnimation(self.smallGrid('13-20',1), 0.07)
		self.explosion2 = anim8.newAnimation(self.smallGrid('13-20',1), 0.07)
		self.crater = anim8.newAnimation(self.animationGrid('1-6',8), 0.07)
		
		self.velExplode1= {x=math.random(-3*13,3*13);y=math.random(-10*8,-3*8)};
		self.posExplode1= {x=0;y=0 }
		
		self.velExplode2= {x=math.random(-3*13,3*13);y=math.random(-5*8,-3*8)};
		self.posExplode2= {x=0;y=0 }
		
		self.debris={}
		
    end,
    depth = 1;
	x = 0;
	y = 0;
	size = 0 ;
	tminus = 0;
	tminusMax = 1;
	splodeTime = .4;
	remove = false;
	animationGrid =  anim8.newGrid(32, 32, sprites.exploSheet:getWidth(), sprites.exploSheet:getHeight());
	smallGrid =  anim8.newGrid(16, 16, sprites.exploSheet:getWidth(), sprites.exploSheet:getHeight());
	bombGrid =  anim8.newGrid(16, 16, sprites.bombs:getWidth(), sprites.bombs:getHeight());
	
	
	velExplode1= {x=math.random(-3,3);y=math.random(-5,-3) };
	posExplode1= {x=0;y=0 }
}

 
 

function Bomb:update(dt)
	if not self.p1.dead then
		if self.tminus > 0 then
			self.tminus = self.tminus - dt
		else
			
			if self.splodeTime == .4 then
				shake()
				
				table.insert(self.debris, {o=math.random(-5,5),p=math.random(0,5),x=math.random(-5,5),y=math.random(0,5),xS=(math.random()*38)-19,yS=(math.random()*15)-56 ,r=math.random()})
				table.insert(self.debris, {o=math.random(-5,5),p=math.random(0,5),x=math.random(-5,5),y=math.random(0,5),xS=(math.random()*38)-19,yS=(math.random()*15)-56 ,r=math.random()})
				table.insert(self.debris, {o=math.random(-5,5),p=math.random(0,5),x=math.random(-5,5),y=math.random(0,5),xS=(math.random()*38)-19,yS=(math.random()*15)-56 ,r=math.random()})
				table.insert(self.debris, {o=math.random(-5,5),p=math.random(0,5),x=math.random(-5,5),y=math.random(0,5),xS=(math.random()*38)-19,yS=(math.random()*15)-56 ,r=math.random()})
				table.insert(self.debris, {o=math.random(-5,5),p=math.random(0,5),x=math.random(-5,5),y=math.random(0,5),xS=(math.random()*38)-19,yS=(math.random()*15)-56 ,r=math.random()})

				
				score = score + 5 
				if self.p1 then
					if math.dist(self.p1.x, self.p1.y, self.x,self.y) < 25 then
						self.p1.dead = true;
					elseif math.dist(self.p1.x, self.p1.y, self.x,self.y) < 40 then
						extraScore = extraScore + 200;
						self.nearMiss = true;	
						nearMisses = nearMisses + 1
					end
					local shit = love.math.random(1,3);
					if shit ==1 then
						bombSound1:play()
					elseif shit ==2 then
						bombSound2:play()
					else
						bombSound3:play()
					end
				end
			end
			self.splodeTime  = self.splodeTime - dt
			self.animation:update(dt)
			self.explosion1:update(dt)
			self.explosion2:update(dt)
			self.crater:update(dt)
			
			
			for k, v in pairs(self.debris) do		
				self.debris[k].x = self.debris[k].x + self.debris[k].xS * dt * 2
				self.debris[k].y = self.debris[k].y + self.debris[k].yS * dt *4
				self.debris[k].yS = self.debris[k].yS + 100 *dt
				self.debris[k].r = self.debris[k].r  + (self.debris[k].xS) * dt
				if self.debris[k].y > 5 then
					 self.debris[k].y =self.debris[k].y - self.debris[k].yS * dt *4
					self.debris[k].yS = -self.debris[k].yS *.4
					
				end
			end
			self.posExplode1.x = self.posExplode1.x + self.velExplode1.x * dt
			self.posExplode1.y = self.posExplode1.y + self.velExplode1.y * dt
			
			 self.velExplode1.y =  self.velExplode1.y+( 200* dt)
			
			
			self.posExplode2.x = self.posExplode2.x + self.velExplode2.x * dt
			self.posExplode2.y = self.posExplode2.y + self.velExplode2.y * dt
			
			 self.velExplode2.y =  self.velExplode2.y+( 200* dt)
			
			
	
		end
		if self.tminusMax == -1 then
			self.tminusMax = self.tminus
		end	
			end
		if self.splodeTime <= -4 then
			self.remove = true
		end

end

function Bomb:draw()
	love.graphics.setColor(255,255,255,255)
	if self.tminus>0 then
		local t = .7-((self.tminus/self.tminusMax)*.6)+.1
		local t2 = (self.tminus/self.tminusMax)
		
		love.graphics.setColor(0,0,0,100)
		
		
			local xMod = (self.x - cam.x)
		local yMod = (-(self.y  -cam.y- 122))
		
		
		if xMod>0 then
			xMod = (xMod * xMod)/3
		else
			
			xMod = (xMod * -xMod)/3
		end
			
		xMod = xMod / (yMod*cam.scale)
	
		
		self.blackBomb:draw(sprites.bombs, self.x, self.y,0,1*t,1*t,8,8)
		
		love.graphics.setColor(255,255,255,255)
		
		local z =  ((self.y -(cam.y -122)) / 244)
		
	
		
		--love.graphics.circle('fill', self.x+(xMod) ,self.y, 5)
		
		
		self.bombDrop:draw(sprites.exploSheet, self.x, self.y,0,(1*t) * ((.2 * z)+.8 )  ,(1*t)*((.2 * z)+.8 ) ,16,10)
		
		
		
		self.blackBomb:draw(sprites.bombs, self.x, (-600 * t2 ) + self.y  ,0,1,1,8,8)
		
		--love.graphics.ellipse('fill',self.x,self.y, (10*t) + 10, (5*t) + 5  )
	else
		love.graphics.setColor(255,255,255,255)
		--love.graphics.ellipse('fill',self.x,self.y, 40, 40  )
		local craterAlpha = self.splodeTime
		if craterAlpha > 0 then
			craterAlpha = 0
		end
		craterAlpha = 1-(-craterAlpha / 4)
	
		
		
		
		for k, v in pairs(self.debris) do		
			love.graphics.push();
			love.graphics.setColor(	0, 77, 0,craterAlpha*205)
			if v.o > 0 then
				love.graphics.setColor(	153, 102, 51,craterAlpha*205)
			end
			love.graphics.translate(self.x+v.x, self.y+v.y)
			love.graphics.rotate(v.r)
			love.graphics.rectangle('fill',0,0,2,2)
			--love.graphics.polygon('fill',  0, 0, 2,3 ,  v.o,v.p  )
			love.graphics.pop();
		end	
		
			love.graphics.setColor(255,255,255,craterAlpha*205)
		love.graphics.setBlendMode('subtract')
		self.crater:draw(sprites.exploSheet,self.x,self.y,0,1,1, 16,16)
		love.graphics.setBlendMode('alpha')
		
		
		
						--love.mousepressed(1, 1, 1)
						
						
		if craterAlpha == 1 then
			
				
				
				
			love.graphics.setColor(255,255,255,200)
			self.animation:draw(sprites.exploSheet, self.x, self.y,0,1.25,1.25,16,16)			
		
			
			self.explosion1:draw(sprites.exploSheet, self.x+self.posExplode1.x, self.y+self.posExplode1.y,0,1,1,8,8)
			
			self.explosion2:draw(sprites.exploSheet, self.x+self.posExplode2.x, self.y+self.posExplode2.y,0,1,1,8,8)
		end
		if self.nearMiss  and craterAlpha > .95 then
			love.graphics.push();
			love.graphics.scale(.5)
		love.graphics.setFont(mainFont)
			love.graphics.setColor(0,0,0,(craterAlpha-.95) * 20   *255);
				love.graphics.print("NEAR\nMISS", 			
					((self.x-10)*2)  , 
					((self.y-19)*2) )
			love.graphics.setColor(255,100,1000,   (craterAlpha-.95) * 20   *255);
			love.graphics.print("NEAR\nMISS", 			
				(self.x+1-10)*2 , 
				(self.y-1-19)*2)
			love.graphics.pop();
		end
	end
end