sprites.hero = love.graphics.newImage('sprites/heroPisk.png')
sprites.hero:setFilter('nearest', 'nearest')

Runner = Class{
    init = function(self)
		self.stand = anim8.newAnimation(self.animationGrid('1-4',1), 0.2)
		self.runForward = anim8.newAnimation(self.animationGrid('28-33',1), 0.08)
		self.runSide = anim8.newAnimation(self.animationGrid('14-19',1), 0.08)
		self.runSide1 = anim8.newAnimation(self.animationGrid('7-12',1), 0.08)
		self.runSide2 = anim8.newAnimation(self.animationGrid('21-25',1), 0.08)
		self.runUp = anim8.newAnimation(self.animationGrid('35-40',1), 0.08)
		self.runUpSide = anim8.newAnimation(self.animationGrid('42-47',1), 0.08)
		
		self.death = anim8.newAnimation(self.animationGrid(5,1), 0.08)
		self.currentAni = self.runForward
		
		self.runningParticles = {};
    end,
    depth = 2;
	x = 0;
	y = 0;
	velocity = {x=0; y=0};
	dashTime = 3;
	dashMultiplier = 0;
	dashing = false;
	animationGrid =  anim8.newGrid(16, 16, sprites.hero:getWidth(), sprites.hero:getHeight());
	reverse = false;
	dead = false;
	deathTimer = 0;
	runTime = 0;
}

function Runner:update(dt)
	if not self.dead then
	
		
		self.x = self.x + dt * self.velocity.x 
		self.y = self.y + dt *  self.velocity.y
		self.reverse = false
		if self.dashTime > .5 and self.dashing then
			self.dashTime = self.dashTime - dt
			self.velocity.x = self.velocity.x+ (((axis1*260)-self.velocity.x)*dt*10)
			self.velocity.y = self.velocity.y+ (((axis2*260)-self.velocity.y)*dt*10)
		else
			self.velocity.x = self.velocity.x+ (((axis1*130)-self.velocity.x)*dt*6)
			self.velocity.y = self.velocity.y+ (((axis2*130)-self.velocity.y)*dt*6)
			if not self.dashing then
			self.dashTime = self.dashTime+(math.abs(self.velocity.x*dt)/680)
			self.dashTime = self.dashTime+(math.abs(self.velocity.y*dt)/680)
			end
		end
		if self.dashTime < 0 then
			self.dashTime = 0.0
		end
			if self.dashTime > 3 then
			self.dashTime = 3
		end
		
		if math.abs(self.velocity.x) + math.abs(self.velocity.y) < 15 then
			self.currentAni = self.stand
		else
			local mAng = math.deg(math.angle(0,0, self.velocity.x,self.velocity.y)  )
			if mAng >= -20 and mAng < 20 then
				self.currentAni = self.runSide
			elseif mAng >= 20 and mAng <= 45 then
				self.currentAni = self.runSide1
			elseif mAng >= 45 and mAng <= 70 then
				self.currentAni = self.runSide2
			elseif mAng >= 70 and mAng <= 110 then
				self.currentAni = self.runForward
			elseif mAng >= 110 and mAng <= 135 then
				self.currentAni = self.runSide2
				self.reverse = true
			elseif mAng >= 135 and mAng <= 160 then
				self.currentAni = self.runSide1
				self.reverse = true
			elseif (mAng >= 160 and mAng <= 180) or (mAng >= -180 and mAng <= -160 )  then
				self.currentAni = self.runSide
				self.reverse = true
			elseif (mAng >= -160 and mAng <= -135 )  then
				self.currentAni = self.runUpSide 
				self.reverse = true
			elseif (mAng >= -135 and mAng <= -45 )  then
				self.currentAni = self.runUp
			elseif (mAng >= -45 and mAng <= -20 )  then
				self.currentAni = self.runUpSide 
			end
		end
	end
	
	if self.currentAni ~= self.stand then
		if not stepSound:isPlaying() then
			stepSound:play()
		end
		
	else	
		stepSound:pause()
	end
	if self.dead then
		stepSound:pause()
		self.deathTimer = self.deathTimer + dt
		self.currentAni = self.death 
	end
		

	self.currentAni:update(dt)


	
	self.runTime = self.runTime + dt
	if self.runTime > .2 then
		if self.currentAni ~= self.stand then
			table.insert(self.runningParticles, {x=self.x+math.random(-4,4), y=self.y+math.random(-4,4), 
					xSpeed=(math.random()*60)-30, ySpeed=(math.random()*60)-30, 
					q =math.random(-2,2), w=math.random(-2,2), e =math.random(-2,2),
					life = .5})
			self.runTime = 0;
		end
		
	end
	
	
	local friction = 2;
	local xRatio = 1 / (1 + (dt * friction));


	for k, v in pairs(self.runningParticles) do	
		self.runningParticles[k].x = v.x +  (v.xSpeed*dt)
		self.runningParticles[k].y = v.y +  (v.ySpeed*dt)
		
		
		self.runningParticles[k].xSpeed = v.xSpeed * xRatio
		self.runningParticles[k].ySpeed = v.ySpeed * xRatio
		self.runningParticles[k].life = self.runningParticles[k].life - dt
		if self.runningParticles[k].life<0 then
			self.runningParticles[k] = nil;
		end
		
	end
	
	
end

function Runner:draw()
	love.graphics.setColor(0,0,0,155)
	if self.dead then
		love.graphics.setColor(255,255,255,255)
		self.currentAni:draw(sprites.hero, self.x+self.deathTimer*190, self.y-self.deathTimer*100,self.deathTimer*15,-1,1,8,15)
		return
	end
	love.graphics.ellipse('fill',self.x,self.y, 7, 2 )
	
	--love.graphics.draw(sprites.hero,self.x-5,self.y-15)
	
	love.graphics.setColor(255,255,255,170)
	for k, v in pairs(self.runningParticles) do	
		love.graphics.rectangle('fill', v.x+v.q, v.y+v.w,1.5+(1.5-v.life*3),1.5+(1.5-v.life*3))
		love.graphics.rectangle('fill', v.x, v.y,1.5+(1.5-v.life*3),1.5+(1.5-v.life*3))
	--	love.graphics.rectangle('fill', v.x+v.w, v.y+v.e,1.5+(1.5-v.life*3),1.5+(1.5-v.life*3))

	end
	
	love.graphics.setColor(255,255,255,255)
	
	if self.reverse then
		self.currentAni:draw(sprites.hero, self.x, self.y,0,-1,1,8,15)
	else
		self.currentAni:draw(sprites.hero, self.x, self.y,0,1,1,8,15)
	end
	
end
